#!/usr/bin/env python
#-*- coding: iso-8859-1 -*-
###############################################################################

__all__ = [ "process_request" ]

###############################################################################

import interlocked_counter; from interlocked_counter import InterlockedCounter

request_count = InterlockedCounter()

def process_request(request: dict, response: dict):

    request_number = request_count.next()

    # synchronous call to another cage fails immediately if the target cage
    # is down or there is a communication problem

    try:
        result = pmnc("receiver").some_module.sync_call(request_number)
    except Exception as e:
        pmnc.log("SYNC REQUEST {0:d} FAILED: {1:s}".format(request_number, e))
    else:
        pmnc.log("SYNC REQUEST {0:d} RETURNED {1:s}".format(request_number, result))

    # asynchronous call doesn't fail, if the target cage is not available
    # or an exception occurs, the call is retried again and again

    pmnc("receiver", queue = "retry").some_module.async_call(request_number)
    pmnc.log("ASYNC REQUEST {0:d} HAS BEEN ENQUEUED".format(request_number))

###############################################################################
# EOF